/***

PROJECT: DevStops by Kase's "Trading with the Odds"
AUTHOR: Kalenzo
CODER: Kalenzo, bartlomiej.gorski@gmail.com
LINK: http://www.fxservice.eu

***/ 

#property copyright "Kalenzo, bartlomiej.gorski@gmail.com"
#property link "http://www.fxservice.eu"
#property indicator_chart_window
#property indicator_buffers 4

#property indicator_color1 Red
#property indicator_color2 Magenta
#property indicator_color3 Yellow
#property indicator_color4 Blue

extern int 	stopPeriod = 20,
			limit = 200;

double 	hl[],
		avtr[],
		sd[],
		b1[],
		b2[],
		b3[],
		b4[],
		bt1[1],
		bt2[1],
		bt3[1],
		bt4[1];
		
int init()
{
	IndicatorBuffers(7);
	
	SetIndexBuffer(0,b1);
	SetIndexBuffer(1,b2);
	SetIndexBuffer(2,b3);
	SetIndexBuffer(3,b4);	
	
	SetIndexStyle(0,DRAW_LINE,STYLE_SOLID,1);
	SetIndexStyle(1,DRAW_LINE,STYLE_SOLID,1);
	SetIndexStyle(2,DRAW_LINE,STYLE_SOLID,1);
	SetIndexStyle(3,DRAW_LINE,STYLE_SOLID,1);
	
	SetIndexBuffer(4,hl);
	SetIndexBuffer(5,avtr);
	SetIndexBuffer(6,sd);	
		
	return(0);
}		
int start()
{
	for(int i=limit;i>=0;i--) hl[i] = High[Highest(Symbol(),0,MODE_HIGH,2,i)] -  Low[Lowest(Symbol(),0,MODE_LOW,2,i)];	
	for(int j=limit-stopPeriod;j>=0;j--) avtr[j] = iMAOnArray(hl,0,stopPeriod,0,MODE_SMA,j);
	for(int k=limit-stopPeriod;k>=0;k--) sd[k] = iStdDevOnArray(hl,0,stopPeriod,0,MODE_SMA,k);
	
	ArrayInitialize(bt1,0);
	ArrayInitialize(bt2,0);
	ArrayInitialize(bt3,0);
	ArrayInitialize(bt4,0);
	
	ArrayResize(bt1,limit-stopPeriod+1);
	ArrayResize(bt2,limit-stopPeriod+1);
	ArrayResize(bt3,limit-stopPeriod+1);
	ArrayResize(bt4,limit-stopPeriod+1);
	
	for(int l = limit-stopPeriod; l>=0; l--)
	{
	 	bt1[l] = High[l] - avtr[l] - 3.6 * sd [l];
		bt2[l] = High[l] - avtr[l] - 2.2 * sd [l];
		bt3[l] = High[l] - avtr[l] - sd [l];
		bt4[l] = High[l] - avtr[l];
	}
		
	for(int m = limit-stopPeriod; m>=0; m--)
	{
		b1[m] = bt1[ArrayMaximum(bt1,stopPeriod,m)];
		b2[m] = bt2[ArrayMaximum(bt2,stopPeriod,m)];
		b3[m] = bt3[ArrayMaximum(bt3,stopPeriod,m)];
		b4[m] = bt4[ArrayMaximum(bt4,stopPeriod,m)];
	}	
	return(0);
}